import java.util.*;
import java.io.*;

public class H {

	int m;
	ArrayList<Integer> graph[] = new ArrayList[50010];
	int edges[][] = new int[50010][2];
	boolean realArticulationPoint[] = new boolean[50010];
	boolean articulationPoint[] = new boolean[50010];
	boolean vertexUsed[] = new boolean[50010];

	int val[] = new int[50100];
	int id;
	
	int visit(int k) // DFS to find articulation points                                                               
	{
		int m, min;
		val[k] = ++id;
		min = id;
		for(int i=0;i<graph[k].size();i++) {
			int nk = graph[k].get(i);
			if( val[nk]==-1)
			{
				m = visit(nk);
				if (m < min) min = m;
				if (m >= val[k]) {
					vertexUsed[k] = true;
					articulationPoint[k] = true;
				}
			}
			else if(val[nk]<min) min = val[nk];
		}
		return min;
	}

	long componentSize;
	boolean visitNow(int s) {
		LinkedList<Integer> q = new LinkedList<Integer>();
		q.add(s);
		vertexUsed[s] = true;
		componentSize++;
		
		int articulationPointID = -1;
		boolean leaf = true;
		
		while(q.size()>0) {
			int v = q.removeFirst();
			for(int i=0;i<graph[v].size();i++) {
				int nv = graph[v].get(i);
				if(articulationPoint[nv]) {
					if(articulationPointID==-1) {
						articulationPointID = nv;
					}
					else if(articulationPointID!=nv) {
						leaf = false;
					}
				}
				if(!vertexUsed[nv]) {
					vertexUsed[nv] = true;
					componentSize++;
					q.add(nv);
				}
			}
		}
		
		return leaf;
	}

	public void doIt() throws Exception {
		Scanner sc = new Scanner(System.in);
		PrintStream ps = System.out;
//		Scanner sc = new Scanner(new File("mining.in"));
//		PrintStream ps = new PrintStream(new File("mining.out"));

		for(int testno=1;;testno++) {
			int n = sc.nextInt();
			if(n==0) break;

			int maxID = 0;
			for(int i=0;i<n;i++) {
				int s = sc.nextInt();
				int t = sc.nextInt();

				edges[i][0] = s;
				edges[i][1] = t;

				maxID = Math.max(maxID, s);
				maxID = Math.max(maxID, t);
			}

			m = maxID;
			for(int i=1;i<=m;i++) graph[i] = new ArrayList<Integer>();

			for(int i=0;i<n;i++) {
				int s = edges[i][0];
				int t = edges[i][1];
				graph[s].add(t);
				graph[t].add(s);
			}

			{
				for(int i=1;i<=m;i++) val[i] = -1;
				for(int i=1;i<=m;i++) vertexUsed[i] = false;
				for(int i=1;i<=m;i++) articulationPoint[i] = false;
				id = 1;
				visit(1);
				for(int i=1;i<=m;i++) realArticulationPoint[i] = articulationPoint[i];
			}
			{
				//giant hack!
				//this articulation code is not working as intended.
				//i.e. it marks the first visited point as an articulation point.
				//therefore, here, visit at 1, and visit at 2.
				//and if both agree, then those are articulation points.
				
				for(int i=1;i<=m;i++) val[i] = -1;
				for(int i=1;i<=m;i++) vertexUsed[i] = false;
				for(int i=1;i<=m;i++) articulationPoint[i] = false;
				id = 1;
				visit(2);
				for(int i=1;i<=m;i++) realArticulationPoint[i] = (realArticulationPoint[i] && articulationPoint[i]);
				
				for(int i=1;i<=m;i++) articulationPoint[i] = realArticulationPoint[i];
				for(int i=1;i<=m;i++) vertexUsed[i] = realArticulationPoint[i];
			}
			
			int totalArticulationPoints = 0;
			
			for(int i=1;i<=m;i++) if(articulationPoint[i]) {
//				if(i<10) System.out.printf("%d\n", i);
				totalArticulationPoints++;
			}
//			System.out.printf("%d) total articulation points = %d\n", testno, totalArticulationPoints);
			
			long totalCombo = 1;
			int totalComponents = 0;
			if(totalArticulationPoints==0) {
				totalComponents = 2;
				long ml = m;
				totalCombo = ml * (ml-1) / 2;
			}
			else {
				for(int i=1;i<=m;i++) {
					if(!vertexUsed[i]) {
						componentSize = 0;
						if(visitNow(i)) {
							totalComponents++;
							totalCombo *= componentSize;
						}
					}
				}
			}
			
			ps.printf("Case %d: %d %d\n", testno, totalComponents, totalCombo);
//			System.out.printf("Case %d: %d %d\n", testno, totalComponents, totalCombo);
		}
	}

	public static void main(String args[]) throws Exception {
		(new H()).doIt();
	}
}

/*
9 1 3 4 1 3 5 1 2 2 6 1 5 6 3 1 6 3 2 6 1 2 1 3 2 4 2 5 3 6 3 7 0
*/

